#ifndef __HOMEPAGES_H__

#define __HOMEPAGES_H__

#include <boost/utility.hpp>
#include <string>
#include <cstring>
#include <map>
#include "bibtexParser.h"

struct ltAuthor
{
  bool operator()( const Author& a1, const Author& a2 ) const
  {
    int res = strcasecmp( a1.last().c_str(), a2.last().c_str() );
    if( res == 0 )
    {
      // Check first initial
      return( tolower( (a1.first())[0] ) < tolower( (a2.first())[0] ) );
    }

    return (res < 0);
  }
};

class HomePages : public boost::noncopyable
{
public:
  HomePages( const std::string& filename );
  std::string pageForName( const Author& name ) const;

private:
  typedef std::map<Author, std::string, ltAuthor> HomePageMap;
  HomePageMap homePages_;
};

#endif

