#ifndef __HTTPWRAPPER_H__
#define __HTTPWRAPPER_H__

#include <Magick++.h>

#include <string>
#include <vector>

#include <boost/shared_ptr.hpp>

/*
class ILImageWrapper
{
public:
  ILImageWrapper();
  ~ILImageWrapper();
  ILuint imageId() const;

private:
  ILuint image_;
};

class ILBindImage
{
public:
  ILBindImage(ILuint imageId);
  ~ILBindImage();
};
*/


class HttpResponse
{
public:
  HttpResponse()
    : size_(0) {}

  std::string contentType() const   { return contentType_; }
  unsigned long size() const        { return size_; }
  std::vector<char> data() const    { return data_; }
  unsigned int errorCode() const	{ return errorCode_; }

private:
  std::vector<char> data_;
  unsigned long size_;
  std::string contentType_;
  unsigned int errorCode_;

  friend size_t write_data( void *ptr, size_t size, size_t nmemb, void *stream );
  friend size_t write_header( void *ptr, size_t size, size_t nmemb, void *stream );
};

class ImageResponse : public HttpResponse
{
public:
  ImageResponse( HttpResponse resp, const Magick::Image& imageWrapper );

  unsigned int width() const;
  unsigned int height() const;
	const Magick::Image& image() const;

private:
  unsigned int width_;
  unsigned int height_;
  Magick::Image image_;
};

const HttpResponse getHeader( const std::string& url );
const ImageResponse getImage( const std::string& url );

#endif

