#ifndef __UTILITY_H__
#define __UTILITY_H__

#include <string>
#include <iostream>

#include <boost/filesystem/path.hpp>

// shared utility functions.

template <typename Streamtype>
typename Streamtype::pos_type filelen( Streamtype& ifs )
{
  typename Streamtype::pos_type curPos = ifs.tellg();
  ifs.seekg(0, std::ios::end);
  typename Streamtype::pos_type l = ifs.tellg();
  ifs.seekg(curPos, std::ios::beg);

  return l;
}

// Read a file and dump it to the output stream
void copyFile( const std::string& filename, std::ostream& os );

// move file to file.old and move file.new to file, in outputPath
void swapFile( const std::string& filename, const boost::filesystem::path& outputPath );

#endif

